package org.omg.CORBA.portable;

import org.omg.CORBA.SetOverrideType;
import org.omg.CORBA.DomainManager;
import org.omg.CORBA.Policy;
import org.omg.CORBA.ORB;
import java.lang.reflect.InvocationTargetException;
import org.omg.CORBA.NO_IMPLEMENT;
import org.omg.CORBA.ContextList;
import org.omg.CORBA.ExceptionList;
import org.omg.CORBA.NamedValue;
import org.omg.CORBA.NVList;
import org.omg.CORBA.Context;
import org.omg.CORBA.Request;
import org.omg.CORBA.BAD_OPERATION;
import org.omg.CORBA.Object;

public abstract class ObjectImpl implements org.omg.CORBA.Object
{
    private transient Delegate __delegate;
    
    public ObjectImpl() {
    }
    
    public Delegate _get_delegate() {
        if (this.__delegate == null) {
            throw new BAD_OPERATION("The delegate has not been set!");
        }
        return this.__delegate;
    }
    
    public void _set_delegate(Delegate _delegate) {
        this.__delegate = _delegate;
    }
    
    public abstract String[] _ids();
    
    public org.omg.CORBA.Object _duplicate() {
        return this._get_delegate().duplicate(this);
    }
    
    public void _release() {
        this._get_delegate().release(this);
    }
    
    public boolean _is_a(String s) {
        return this._get_delegate().is_a(this, s);
    }
    
    public boolean _is_equivalent(org.omg.CORBA.Object object) {
        return this._get_delegate().is_equivalent(this, object);
    }
    
    public boolean _non_existent() {
        return this._get_delegate().non_existent(this);
    }
    
    public int _hash(int n) {
        return this._get_delegate().hash(this, n);
    }
    
    public Request _request(String s) {
        return this._get_delegate().request(this, s);
    }
    
    public Request _create_request(Context context, String s, NVList list, NamedValue namedValue) {
        return this._get_delegate().create_request(this, context, s, list, namedValue);
    }
    
    public Request _create_request(Context context, String s, NVList list, NamedValue namedValue, ExceptionList list2, ContextList list3) {
        return this._get_delegate().create_request(this, context, s, list, namedValue, list2, list3);
    }
    
    public org.omg.CORBA.Object _get_interface_def() {
        Delegate get_delegate = this._get_delegate();
        try {
            return get_delegate.get_interface_def(this);
        }
        catch (NO_IMPLEMENT no_IMPLEMENT) {
            try {
                return (org.omg.CORBA.Object)get_delegate.getClass().getMethod("get_interface", new Class[] { org.omg.CORBA.Object.class }).invoke(get_delegate, new Object[] { this });
            }
            catch (InvocationTargetException ex) {
                Throwable targetException = ex.getTargetException();
                if ((targetException instanceof Error)) {
                    throw (Error)targetException;
                }
                if ((targetException instanceof RuntimeException)) {
                    throw (RuntimeException)targetException;
                }
                throw new NO_IMPLEMENT();
            }
            catch (RuntimeException ex2) {
                throw ex2;
            }
            catch (Exception ex3) {
                throw new NO_IMPLEMENT();
            }
        }
    }
    
    public ORB _orb() {
        return this._get_delegate().orb(this);
    }
    
    public Policy _get_policy(int n) {
        return this._get_delegate().get_policy(this, n);
    }
    
    public DomainManager[] _get_domain_managers() {
        return this._get_delegate().get_domain_managers(this);
    }
    
    public org.omg.CORBA.Object _set_policy_override(Policy[] array, SetOverrideType setOverrideType) {
        return this._get_delegate().set_policy_override(this, array, setOverrideType);
    }
    
    public boolean _is_local() {
        return this._get_delegate().is_local(this);
    }
    
    public ServantObject _servant_preinvoke(String s, Class clazz) {
        return this._get_delegate().servant_preinvoke(this, s, clazz);
    }
    
    public void _servant_postinvoke(ServantObject servantObject) {
        this._get_delegate().servant_postinvoke(this, servantObject);
    }
    
    public OutputStream _request(String s, boolean b) {
        return this._get_delegate().request(this, s, b);
    }
    
    public InputStream _invoke(OutputStream outputStream) throws ApplicationException, RemarshalException {
        return this._get_delegate().invoke(this, outputStream);
    }
    
    public void _releaseReply(InputStream inputStream) {
        this._get_delegate().releaseReply(this, inputStream);
    }
    
    @Override
    public String toString() {
        if (this.__delegate != null) {
            return this.__delegate.toString(this);
        }
        return this.getClass().getName() + ": no delegate set";
    }
    
    @Override
    public int hashCode() {
        if (this.__delegate != null) {
            return this.__delegate.hashCode(this);
        }
        return super.hashCode();
    }
    
    @Override
    public boolean equals(Object o) {
        if (this.__delegate != null) {
            return this.__delegate.equals(this, o);
        }
        return this == o;
    }
}
